from utils import implies

FRUITS = [
	{
		"name": "Banana",
		"tropical": True,
		"delicious": True,
		"at_walmart": True,
	},
	{
		"name": "Dragon Fruit",
		"delicious": True,
		"at_walmart": False,
		"tropical": True,
	},
	{
		"name": "Orange",
		"delicious": False,
		"at_walmart": True,
		"tropical": True,
	},
	{
		"name": "Mango",
		"delicious": True,
		"at_walmart": False,
		"tropical": True,
	},
	{
		"name": "Watermelon",
		"delicious": True,
		"at_walmart": True,
		"tropical": True,
	},
]

def T(x):
	return x["tropical"]

def D(x):
	return x["delicious"]

def W(x):
	return x["at_walmart"]

U = FRUITS

# If a tropical fruit is delicious then it is available in Walmart.
# ∀x [(T(x) ∧ D(x)) → W(x)]
prop = all(map(lambda x: implies(T(x) and D(x), W(x)), U))
print("If a tropical fruit is delicious then it is available in Walmart.")
print("∀x [(T(x) ∧ D(x)) → W(x)]: ", prop)
