from data import CPSC1820_STUDENTS
from utils import implies

def C(x):
	return x["is_cs_student"]

def E(x):
	return x["is_ee_student"]

def S(x):
	return x["is_smart"]

U = CPSC1820_STUDENTS

# Everyone is a CPSC student.
# ∀x C(x)
prop1 = all(map(C, U))
print("Every is a CPSC student")
print("∀x C(x): ", prop1)
print()

# Nobody is an ECE student.
# ∀x ¬E(x) or ¬∃x E(x)
prop2_a = all(map(lambda x: not E(x), U))
prop2_b = not any(map(E, U))
print("Nbody is an ECE student")
print("∀x ¬E(x) ", prop2_a)
print("¬∃x E(x) ", prop2_b)
print()

# All CPSC students are smart students
prop3 = all(map(lambda x: implies(C(x), S(x)), U))
print("All CPSC students are smart students")
print("∀x [C(x) → S(x)]: ", prop3)
print()

# Some CPSC students are smart students.
# ∃x [C(x) ∧ S(x)]
prop4 = any(map(lambda x: C(x) and S(x), U))
print("Some CPSC students are smart students")
print("∃x [C(x) ∧ S(x)]: ", prop4)
print()

# No CPSC student is an ECE student.”
# – If x is a CPSC student, then that student is not an ECE student.
# ∀x [C(x) → ~E(x)]
# – There does not exist a CPSC student who is also an ECE student.
# ¬∃x [C(x) ∧ E(x)]
prop5 = all(map(lambda x: implies(C(x), not E(x)), U))
prop6 = not any(map(lambda x: C(x) and E(x), U))
print("No CPSC student is an ECE student.")
print("∀x [C(x) → ~E(x)]: ", prop5)
print("¬∃x [C(x) ∧ E(x)]: ", prop6)
print()

# “If any ECE student is a smart student then he is also a CPSC student.”
# ∀x [(E(x) ∧ S(x)) → C(x)]
prop7 = all(map(lambda x: implies(E(x) and S(x), C(x)), U))
print("If any ECE student is a smart student, then he is also a CPSC student.")
print("∀x [(E(x) ∧ S(x)) → C(x)]: ", prop7)
